package io.gitlab.jfronny.combit.mixin;

import io.gitlab.jfronny.combit.Combit;
import io.gitlab.jfronny.combit.config.Invulnerability;
import io.gitlab.jfronny.combit.nodami.EntityHurtCallback;
import io.gitlab.jfronny.combit.nodami.EntityKnockbackCallback;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.damage.DamageSource;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.util.ActionResult;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(LivingEntity.class)
public class LivingEntityMixin {
    @Inject(at = @At("TAIL"), method = "applyDamage", cancellable = true)
    private void onEntityHurt(final DamageSource source, final float amount, CallbackInfo info) {
        if (Combit.getCfg().invulnerability.enable) {
            ActionResult result = EntityHurtCallback.EVENT.invoker().hurtEntity((LivingEntity) (Object) this, source,
                    amount);
            if (result == ActionResult.FAIL) {
                info.cancel();
            }
        }
    }

    @Inject(at = @At("HEAD"), method = "takeKnockback", cancellable = true)
    private void onTakingKnockback(float amp, double dx, double dz, CallbackInfo info) {
        if (Combit.getCfg().invulnerability.enable) {
            ActionResult result = EntityKnockbackCallback.EVENT.invoker().takeKnockback((LivingEntity) (Object) this, amp, dx, dz);
            if (result == ActionResult.FAIL) {
                info.cancel();
            }
        }
    }
}
